#include <libglademm/xml.h>
#include <gtkmm.h>
#include <iostream>
#include <vector>

using namespace std;

#include <boost/shared_ptr.hpp>

using namespace boost;

#include "TreeViewObject.h"
#include "TreeViewBase.h"
#include "ListViewBase.h"
#include "TreeViewDerived.h"
#include "ListViewDerived.h"

#include "../AppData.h"

/////////////////////////////////////////////////////////////////////

extern AppData data;

/////////////////////////////////////////////////////////////////////

ListViewDerived::ListViewDerived(GtkTreeView* cobject, const Glib::RefPtr<Gnome::Glade::Xml>& refGlade) : ListViewBase(cobject,refGlade)
{
  connectSignals();
  initColumns();
  addRows();
}

/////////////////////////////////////////////////////////////////////

void ListViewDerived::connectSignals()
{
  Glib::RefPtr<Gtk::TreeSelection> sel = get_selection();
  sel->signal_changed().connect( sigc::mem_fun(*this, &ListViewDerived::on_selection_changed) );
  // Use a 'before' event handler for button press event.
  signal_button_press_event().connect( sigc::mem_fun(*this, &ListViewDerived::button_press_event), false );
}

void ListViewDerived::initColumns()
{
  vector<vector<ColumnType> > columnSpec;

  columnSpec.push_back( vector<ColumnType>() );
  columnSpec.back().push_back(ColTypePixbuf);
  columnSpec.back().push_back(ColTypeText);

  columnSpec.push_back( vector<ColumnType>() );
  columnSpec.back().push_back(ColTypeText);

  columnSpec.push_back( vector<ColumnType>() );
  columnSpec.back().push_back(ColTypeText);

  columnSpec.push_back( vector<ColumnType>() );
  columnSpec.back().push_back(ColTypeToggle);
  columnSpec.back().push_back(ColTypeText);

  init( columnSpec );
}

void ListViewDerived::addRows()
{
  Gtk::TreeIter iter = model()->append();
  iter = model()->append();
  iter = model()->append();
  iter = model()->append();
  iter = model()->append();
  iter = model()->append();

  const char* folder = "/home/gnome/garnome/share/icons/gnome/16x16/places/folder.png";
  const char* folder_home = "/home/gnome/garnome/share/icons/gnome/16x16/places/folder_home.png";

  for ( iter = getRoot(); iter; iter++ ) {
    setImage(  iter, 0, 0, folder );
    setText(   iter, 0, 1, "Text1" );
    setText(   iter, 1, 0, "Text2" );
    setText(   iter, 2, 0, "Text3" );
    setToggle( iter, 3, 0, true );
    setText(   iter, 3, 1, "Text4" );
  }
}

/////////////////////////////////////////////////////////////////////

void ListViewDerived::on_selection_changed()
{
}

/////////////////////////////////////////////////////////////////////

bool ListViewDerived::button_press_event(GdkEventButton* event)
{
  // Display popup if this is a right click.
  if ( event->button == 3 )
    data.pMenu->popup( event->button, event->time );

// TRUE to stop other handlers from being invoked for the event.
// FALSE to propagate the event further.
  return( false );
}

/////////////////////////////////////////////////////////////////////

