#include <libglademm/xml.h>
#include <gtkmm.h>
#include <iostream>
#include <vector>

using namespace std;

#include <boost/shared_ptr.hpp>

using namespace boost;

#include "TreeViewObject.h"
#include "TreeViewBase.h"
#include "ListViewBase.h"
#include "TreeViewDerived.h"
#include "ListViewDerived.h"

#include "../AppData.h"

/////////////////////////////////////////////////////////////////////

extern AppData data;

/////////////////////////////////////////////////////////////////////

TreeViewDerived::TreeViewDerived(GtkTreeView* cobject, const Glib::RefPtr<Gnome::Glade::Xml>& refGlade) : TreeViewBase(cobject,refGlade)
{
  connectSignals();
  initColumns();
  addRows();
}

/////////////////////////////////////////////////////////////////////

void TreeViewDerived::connectSignals()
{
  Glib::RefPtr<Gtk::TreeSelection> sel = get_selection();
  sel->signal_changed().connect( sigc::mem_fun(*this, &TreeViewDerived::on_selection_changed) );
  // Use a 'before' event handler for button press event.
  signal_button_press_event().connect( sigc::mem_fun(*this, &TreeViewDerived::button_press_event), false );
}

void TreeViewDerived::initColumns()
{
  vector<vector<ColumnType> > columnSpec;

  columnSpec.push_back( vector<ColumnType>() );
  columnSpec.back().push_back(ColTypePixbuf);
  columnSpec.back().push_back(ColTypeText);

  columnSpec.push_back( vector<ColumnType>() );
  columnSpec.back().push_back(ColTypePixbuf);
  columnSpec.back().push_back(ColTypeText);
  columnSpec.back().push_back(ColTypeToggle);

  init( columnSpec );
}

void TreeViewDerived::addRows()
{
  Gtk::TreeIter iter;

  model()->append();
  model()->append();
  model()->append();
  model()->append();
  model()->append();
  model()->append();

  const char* folder = "/home/gnome/garnome/share/icons/gnome/16x16/places/folder.png";
  const char* folder_home = "/home/gnome/garnome/share/icons/gnome/16x16/places/folder_home.png";

  for ( iter = getRoot(); iter; iter++ ) {
    setImage(  iter, 0, 0, folder );
    setText(   iter, 0, 1, "Text1" );
    setImage(  iter, 1, 0, folder_home );
    setText(   iter, 1, 1, "Text2" );
    setToggle( iter, 1, 2, true );
    model()->append( iter->children() );
  }
}

/////////////////////////////////////////////////////////////////////

void TreeViewDerived::on_selection_changed()
{
}

/////////////////////////////////////////////////////////////////////

bool TreeViewDerived::button_press_event(GdkEventButton* event)
{
  // Display popup if this is a right click.
  if ( event->button == 3 )
    data.pMenu->popup( event->button, event->time );

// TRUE to stop other handlers from being invoked for the event.
// FALSE to propagate the event further.
  return( false );
}

/////////////////////////////////////////////////////////////////////

