
class TreeViewObject : public Gtk::TreeView
{
public:
  enum ColumnType {
    ColTypePixbuf,
    ColTypeText,
    ColTypeToggle
  };

public:
  TreeViewObject(GtkTreeView* cobject, const Glib::RefPtr<Gnome::Glade::Xml>& refGlade);
  void init( const vector<vector<ColumnType> >& columnSpec );
  void setToggle( Gtk::TreeIter& iter, unsigned viewCol, unsigned index, bool value );
  void setText( Gtk::TreeIter& iter, unsigned viewCol, unsigned index, const Glib::ustring& value );
  void setPixbuf( Gtk::TreeIter& iter, unsigned viewCol, unsigned index, const Glib::RefPtr<Gdk::Pixbuf>& value );
  void setImage( Gtk::TreeIter& iter, unsigned viewCol, unsigned index, const string& fileName );
  Gtk::TreeIter getRoot();

protected:
  virtual Glib::RefPtr<Gtk::TreeModel> create() = 0;

protected:
  vector<vector<ColumnType> > m_columnSpec;
  Gtk::TreeModelColumnRecord m_columnRecord;
  vector<vector<shared_ptr<Gtk::TreeModelColumnBase> > > m_columnTypes;
  Gtk::CellRendererPixbuf m_cellRendererPixbuf;
  Gtk::CellRendererText   m_cellRendererText;
  Gtk::CellRendererToggle m_cellRendererToggle;
  vector<shared_ptr<Gtk::TreeViewColumn> > m_columns;
};

 
